/*******************************************************

FNAm2 by Alexey Kobzin

Implemented by Alexander Myasnikov

Web: www.darksoftware.narod.ru

*******************************************************/

typedef unsigned long u32;

u32 key[16];

u32 Num;


void __stdcall __export
setup (u32 * b)
{

  u32 r;

  for (r = 0; r != 16; r++)
    {
      key[r] = b[r];
    }

  Num = 0;

}


void __stdcall __export
crypt (u32 * b)
{
  int subkey, i, ip, im;

  u32 b1 = b[0];
  u32 b2 = b[1];
  u32 b3 = b[2];
  u32 b4 = b[3];

  u32 r;

  for (r = 0; r != 64; r++)
    {
      //Selecting the part of key for a concrete stage
      i = r % 16;
      if (i == 16)
        {
          ip = 1;
          im = 15;
        }
      if (i == 1)
        {
          ip = 2;
          im = 16;
        }
      else
        {
          ip = i + 1;
          im = i - 1;
        }

      //Generating the subkey on the basis of nmber part of a key,
      //number of the block in a file and number of a round
      subkey = key[i] * r + (key[im] * Num + key[ip]);

      //F - function
      b1 += (((b2 >> 16) ^ ((b2 << 25) + subkey)) + (subkey * (~(b2 << 7))));
      b1 = ~b1;
      r++;

      i = r % 16;
      if (i == 16)
        {
          ip = 1;
          im = 15;
        }
      if (i == 1)
        {
          ip = 2;
          im = 16;
        }
      else
        {
          ip = i + 1;
          im = i - 1;
        }
      subkey = key[i] * r + (key[im] * Num + key[ip]);
      b2 += (((b3 >> 16) ^ ((b3 << 25) + subkey)) + (subkey * (~(b3 << 7))));
      b2 = ~b2;
      r++;

      i = r % 16;
      if (i == 16)
        {
          ip = 1;
          im = 15;
        }
      if (i == 1)
        {
          ip = 2;
          im = 16;
        }
      else
        {
          ip = i + 1;
          im = i - 1;
        }
      subkey = key[i] * r + (key[im] * Num + key[ip]);
      b3 += (((b4 >> 16) ^ ((b4 << 25) + subkey)) + (subkey * (~(b4 << 7))));
      b3 = ~b3;
      r++;

      i = r % 16;
      if (i == 16)
        {
          ip = 1;
          im = 15;
        }
      if (i == 1)
        {
          ip = 2;
          im = 16;
        }
      else
        {
          ip = i + 1;
          im = i - 1;
        }
      subkey = key[i] * r + (key[im] * Num + key[ip]);
      b4 += (((b1 >> 16) ^ ((b1 << 25) + subkey)) + (subkey * (~(b1 << 7))));
      b4 = ~b4;
    }
  Num++;

  b[0] = b1;
  b[1] = b2;
  b[2] = b3;
  b[3] = b4;
}

void __stdcall __export
decrypt (u32 * b)
{
  u32 b1 = b[0];
  u32 b2 = b[1];
  u32 b3 = b[2];
  u32 b4 = b[3];

  int subkey, i, ip, im, r;

  for (r = 63; r != -1; r--)
    {
      i = r % 16;
      if (i == 16)
        {
          ip = 1;
          im = 15;
        }
      if (i == 1)
        {
          ip = 2;
          im = 16;
        }
      else
        {
          ip = i + 1;
          im = i - 1;
        }
      subkey = key[i] * r + (key[im] * Num + key[ip]);
      b4 = ~b4;
      b4 -= (((b1 >> 16) ^ ((b1 << 25) + subkey)) + (subkey * (~(b1 << 7))));
      r--;

      i = r % 16;
      if (i == 16)
        {
          ip = 1;
          im = 15;
        }
      if (i == 1)
        {
          ip = 2;
          im = 16;
        }
      else
        {
          ip = i + 1;
          im = i - 1;
        }
      subkey = key[i] * r + (key[im] * Num + key[ip]);
      b3 = ~b3;
      b3 -= (((b4 >> 16) ^ ((b4 << 25) + subkey)) + (subkey * (~(b4 << 7))));
      r--;

      i = r % 16;
      if (i == 16)
        {
          ip = 1;
          im = 15;
        }
      if (i == 1)
        {
          ip = 2;
          im = 16;
        }
      else
        {
          ip = i + 1;
          im = i - 1;
        }
      subkey = key[i] * r + (key[im] * Num + key[ip]);
      b2 = ~b2;
      b2 -= (((b3 >> 16) ^ ((b3 << 25) + subkey)) + (subkey * (~(b3 << 7))));
      r--;

      i = r % 16;
      if (i == 16)
        {
          ip = 1;
          im = 15;
        }
      if (i == 1)
        {
          ip = 2;
          im = 16;
        }
      else
        {
          ip = i + 1;
          im = i - 1;
        }
      subkey = key[i] * r + (key[im] * Num + key[ip]);
      b1 = ~b1;
      b1 -= (((b2 >> 16) ^ ((b2 << 25) + subkey)) + (subkey * (~(b2 << 7))));
    }
  Num++;

  b[0] = b1;
  b[1] = b2;
  b[2] = b3;
  b[3] = b4;

}
